import * as _visoning_vue_floating_core from '@visoning/vue-floating-core';
import { Middleware, FloatingType, ReferenceType as ReferenceType$1, VirtualElement as VirtualElement$1 } from '@visoning/vue-floating-core';
export { Middleware, MiddlewareData, Placement, Strategy, VirtualElement } from '@visoning/vue-floating-core';
import * as _floating_ui_dom from '@floating-ui/dom';
import { VirtualElement, AutoUpdateOptions as AutoUpdateOptions$1 } from '@floating-ui/dom';
import * as _floating_ui_core from '@floating-ui/core';
import { Strategy, Placement, MiddlewareData, OffsetOptions, ShiftOptions, FlipOptions, AutoPlacementOptions } from '@floating-ui/core';
import * as _visoning_vue_utility from '@visoning/vue-utility';
import * as vue_demi from 'vue-demi';
import { VNode, PropType, ExtractPropTypes, Ref } from 'vue-demi';
import * as Vue3 from 'vue';
import { InteractionInfo as InteractionInfo$1 } from '@visoning/vue-floating-interactions';

declare type ReferenceType = Element | VirtualElement;
interface UseFloatingData {
    x: number | null;
    y: number | null;
    strategy: Strategy;
    placement: Placement;
    middlewareData: MiddlewareData;
}

declare type UseAutoUpdateOptions = Partial<AutoUpdateOptions$1> & {
    /**
     * @default false
     */
    disabled?: boolean;
};

declare type FloatingData = UseFloatingData;
declare type AutoUpdateOptions = UseAutoUpdateOptions;

declare const Popup: Vue3.DefineComponent<_visoning_vue_utility.WithDefaultProps<{
    readonly open: BooleanConstructor;
    readonly disabled: BooleanConstructor;
    readonly virtualElement: Vue3.PropType<_floating_ui_dom.VirtualElement>;
    readonly appendTo: Vue3.PropType<string | false | HTMLElement>;
    readonly autoUpdateOnClosed: BooleanConstructor;
    readonly offset: Vue3.PropType<_floating_ui_core.OffsetOptions>;
    readonly shift: Vue3.PropType<boolean | _floating_ui_core.ShiftOptions>;
    readonly flip: Vue3.PropType<boolean | _floating_ui_core.FlipOptions>;
    readonly autoPlacement: Vue3.PropType<boolean | _floating_ui_core.AutoPlacementOptions>;
    readonly gpuAcceleration: BooleanConstructor;
    readonly destoryedOnClosed: BooleanConstructor;
    readonly referenceProps: Vue3.PropType<Record<string, any>>;
    readonly popupProps: Vue3.PropType<Record<string, any>>;
    readonly popupWrapper: Vue3.PropType<(popup: VNode<Vue3.RendererNode, Vue3.RendererElement, {
        [key: string]: any;
    }> | null) => VNode<Vue3.RendererNode, Vue3.RendererElement, {
        [key: string]: any;
    }>>;
    readonly floatingWrapper: Vue3.PropType<(popup: VNode<Vue3.RendererNode, Vue3.RendererElement, {
        [key: string]: any;
    }> | null) => VNode<Vue3.RendererNode, Vue3.RendererElement, {
        [key: string]: any;
    }>>;
    readonly zIndex: NumberConstructor;
    readonly onFloatingDataUpdate: Vue3.PropType<(data: {
        x: number | null;
        y: number | null;
        strategy: _floating_ui_dom.Strategy;
        placement: _floating_ui_dom.Placement;
        middlewareData: {
            [x: string]: any;
            arrow?: {
                x?: number | undefined;
                y?: number | undefined;
                centerOffset: number;
            } | undefined;
            autoPlacement?: {
                index?: number | undefined;
                overflows: {
                    placement: _floating_ui_dom.Placement;
                    overflows: number[];
                }[];
            } | undefined;
            flip?: {
                index?: number | undefined;
                overflows: {
                    placement: _floating_ui_dom.Placement;
                    overflows: number[];
                }[];
            } | undefined;
            hide?: {
                referenceHidden?: boolean | undefined;
                escaped?: boolean | undefined;
                referenceHiddenOffsets?: {
                    top: number;
                    right: number;
                    bottom: number;
                    left: number;
                } | undefined;
                escapedOffsets?: {
                    top: number;
                    right: number;
                    bottom: number;
                    left: number;
                } | undefined;
            } | undefined;
            offset?: {
                x: number;
                y: number;
            } | undefined;
            shift?: {
                x: number;
                y: number;
            } | undefined;
        };
    }) => void>;
    readonly floating: {
        type: Vue3.PropType<HTMLElement | null>;
    };
    readonly reference: {
        type: Vue3.PropType<_visoning_vue_floating_core.ReferenceType | null>;
    };
    readonly placement: Omit<{
        type: new (...args: any[]) => _floating_ui_dom.Placement & {};
    } | {
        type: () => _floating_ui_dom.Placement;
    } | {
        type: ((new (...args: any[]) => _floating_ui_dom.Placement & {}) | (() => _floating_ui_dom.Placement))[];
    }, "default"> & {
        default: "bottom";
    };
    readonly strategy: Omit<{
        type: new (...args: any[]) => _floating_ui_dom.Strategy & {};
    } | {
        type: () => _floating_ui_dom.Strategy;
    } | {
        type: ((new (...args: any[]) => _floating_ui_dom.Strategy & {}) | (() => _floating_ui_dom.Strategy))[];
    }, "default"> & {
        default: "absolute";
    };
    readonly middleware: Vue3.PropType<Middleware[]>;
    readonly autoUpdate: Omit<{
        type: new (...args: any[]) => (boolean | _visoning_vue_floating_core.UseAutoUpdateOptions) & {};
    } | {
        type: () => boolean | _visoning_vue_floating_core.UseAutoUpdateOptions;
    } | {
        type: ((new (...args: any[]) => (boolean | _visoning_vue_floating_core.UseAutoUpdateOptions) & {}) | (() => boolean | _visoning_vue_floating_core.UseAutoUpdateOptions))[];
    }, "default"> & {
        default: true;
    };
}, {
    readonly appendTo: "body";
    readonly shift: true;
    readonly placement: "bottom";
    readonly strategy: "absolute";
    readonly autoUpdate: true;
}>, () => VNode<Vue3.RendererNode, Vue3.RendererElement, {
    [key: string]: any;
}>, unknown, {}, {}, Vue3.ComponentOptionsMixin, Vue3.ComponentOptionsMixin, {}, string, Vue3.VNodeProps & Vue3.AllowedComponentProps & Vue3.ComponentCustomProps, Readonly<Vue3.ExtractPropTypes<_visoning_vue_utility.WithDefaultProps<{
    readonly open: BooleanConstructor;
    readonly disabled: BooleanConstructor;
    readonly virtualElement: Vue3.PropType<_floating_ui_dom.VirtualElement>;
    readonly appendTo: Vue3.PropType<string | false | HTMLElement>;
    readonly autoUpdateOnClosed: BooleanConstructor;
    readonly offset: Vue3.PropType<_floating_ui_core.OffsetOptions>;
    readonly shift: Vue3.PropType<boolean | _floating_ui_core.ShiftOptions>;
    readonly flip: Vue3.PropType<boolean | _floating_ui_core.FlipOptions>;
    readonly autoPlacement: Vue3.PropType<boolean | _floating_ui_core.AutoPlacementOptions>;
    readonly gpuAcceleration: BooleanConstructor;
    readonly destoryedOnClosed: BooleanConstructor;
    readonly referenceProps: Vue3.PropType<Record<string, any>>;
    readonly popupProps: Vue3.PropType<Record<string, any>>;
    readonly popupWrapper: Vue3.PropType<(popup: VNode<Vue3.RendererNode, Vue3.RendererElement, {
        [key: string]: any;
    }> | null) => VNode<Vue3.RendererNode, Vue3.RendererElement, {
        [key: string]: any;
    }>>;
    readonly floatingWrapper: Vue3.PropType<(popup: VNode<Vue3.RendererNode, Vue3.RendererElement, {
        [key: string]: any;
    }> | null) => VNode<Vue3.RendererNode, Vue3.RendererElement, {
        [key: string]: any;
    }>>;
    readonly zIndex: NumberConstructor;
    readonly onFloatingDataUpdate: Vue3.PropType<(data: {
        x: number | null;
        y: number | null;
        strategy: _floating_ui_dom.Strategy;
        placement: _floating_ui_dom.Placement;
        middlewareData: {
            [x: string]: any;
            arrow?: {
                x?: number | undefined;
                y?: number | undefined;
                centerOffset: number;
            } | undefined;
            autoPlacement?: {
                index?: number | undefined;
                overflows: {
                    placement: _floating_ui_dom.Placement;
                    overflows: number[];
                }[];
            } | undefined;
            flip?: {
                index?: number | undefined;
                overflows: {
                    placement: _floating_ui_dom.Placement;
                    overflows: number[];
                }[];
            } | undefined;
            hide?: {
                referenceHidden?: boolean | undefined;
                escaped?: boolean | undefined;
                referenceHiddenOffsets?: {
                    top: number;
                    right: number;
                    bottom: number;
                    left: number;
                } | undefined;
                escapedOffsets?: {
                    top: number;
                    right: number;
                    bottom: number;
                    left: number;
                } | undefined;
            } | undefined;
            offset?: {
                x: number;
                y: number;
            } | undefined;
            shift?: {
                x: number;
                y: number;
            } | undefined;
        };
    }) => void>;
    readonly floating: {
        type: Vue3.PropType<HTMLElement | null>;
    };
    readonly reference: {
        type: Vue3.PropType<_visoning_vue_floating_core.ReferenceType | null>;
    };
    readonly placement: Omit<{
        type: new (...args: any[]) => _floating_ui_dom.Placement & {};
    } | {
        type: () => _floating_ui_dom.Placement;
    } | {
        type: ((new (...args: any[]) => _floating_ui_dom.Placement & {}) | (() => _floating_ui_dom.Placement))[];
    }, "default"> & {
        default: "bottom";
    };
    readonly strategy: Omit<{
        type: new (...args: any[]) => _floating_ui_dom.Strategy & {};
    } | {
        type: () => _floating_ui_dom.Strategy;
    } | {
        type: ((new (...args: any[]) => _floating_ui_dom.Strategy & {}) | (() => _floating_ui_dom.Strategy))[];
    }, "default"> & {
        default: "absolute";
    };
    readonly middleware: Vue3.PropType<Middleware[]>;
    readonly autoUpdate: Omit<{
        type: new (...args: any[]) => (boolean | _visoning_vue_floating_core.UseAutoUpdateOptions) & {};
    } | {
        type: () => boolean | _visoning_vue_floating_core.UseAutoUpdateOptions;
    } | {
        type: ((new (...args: any[]) => (boolean | _visoning_vue_floating_core.UseAutoUpdateOptions) & {}) | (() => boolean | _visoning_vue_floating_core.UseAutoUpdateOptions))[];
    }, "default"> & {
        default: true;
    };
}, {
    readonly appendTo: "body";
    readonly shift: true;
    readonly placement: "bottom";
    readonly strategy: "absolute";
    readonly autoUpdate: true;
}>>>, {
    readonly open: boolean;
    readonly shift: boolean | _floating_ui_core.ShiftOptions;
    readonly disabled: boolean;
    readonly placement: _floating_ui_dom.Placement;
    readonly strategy: _floating_ui_dom.Strategy;
    readonly autoUpdate: boolean | _visoning_vue_floating_core.UseAutoUpdateOptions;
    readonly appendTo: string | false | HTMLElement;
    readonly autoUpdateOnClosed: boolean;
    readonly gpuAcceleration: boolean;
    readonly destoryedOnClosed: boolean;
}>;

interface PopupExposed {
    updatePosition: () => void;
    getFloatingData: () => FloatingData | undefined;
    getElements: () => {
        floating: FloatingType | undefined;
        reference: ReferenceType$1 | undefined;
    };
}
declare type PopupSlotProps = FloatingData;
declare const PopupPropsType: {
    /**
     * Whether to open popup.
     */
    readonly open: BooleanConstructor;
    /**
     * Whether to disable the floating.
     */
    readonly disabled: BooleanConstructor;
    /**
     * You can position a floating element relative to a virtual element instead of a real one.
     * This enables things like positioning context menus or following the cursor.
     * @see https://floating-ui.com/docs/virtual-elements
     */
    readonly virtualElement: PropType<VirtualElement$1>;
    /**
     * When this value is `true`, popup will be teleport to the target.
     * The teleport to target must be already in the DOM when the <Teleport> component is mounted.
     * @see https://vuejs.org/guide/built-ins/teleport.html
     *
     * Or you can customize the teleport logic, set `appendTo` to false, and use `floatingWrapper`,
     * for simple example
     * ```tsx
     * {
     *   appendTo: false,
     *   floatingWrapper: (floating) => h(
     *    Teleport,
     *    {
     *      to: anyTarget
     *    },
     *    {
     *      default: () => [floating]
     *    }
     *   )
     * }
     * ```
     * @default 'body'
     */
    readonly appendTo: PropType<string | false | HTMLElement>;
    /**
     * When this value is `false`, even if the popup is closed, floating will update the position as needed,
     * unless popup is disabled.
     */
    readonly autoUpdateOnClosed: BooleanConstructor;
    /**
     * Displaces the popup element from its core placement along the specified axes.
     * @see https://floating-ui.com/docs/offset
     */
    readonly offset: PropType<OffsetOptions>;
    /**
     * Moves the popup element along the specified axes in order to keep it in view.
     * @default true
     * @see https://floating-ui.com/docs/shift
     */
    readonly shift: PropType<boolean | ShiftOptions>;
    /**
     * Changes the placement of the popup element to the opposite one by default in order to keep it in view.
     * @see https://floating-ui.com/docs/flip
     */
    readonly flip: PropType<boolean | FlipOptions>;
    /**
     * Chooses the placement that has the most space available automatically.
     *
     * You’ll want to use this instead of `flip` if you don't want to give the popup element a “preferred” placement
     * and let it choose a placement for you.
     * @see https://floating-ui.com/docs/autoPlacement
     */
    readonly autoPlacement: PropType<boolean | AutoPlacementOptions>;
    /**
     * This determines whether GPU-accelerated styles are used to position the popup.
     * When this value is `true`, popup will use the 3D transforms.
     * When this value is `false`, popup will use top/left properties.
     */
    readonly gpuAcceleration: BooleanConstructor;
    /**
     * Whether destroy popup when closed.
     */
    readonly destoryedOnClosed: BooleanConstructor;
    /**
     * HTML attributes of node.
     */
    readonly referenceProps: PropType<Record<string, any>>;
    /**
     * HTML attributes of node.
     */
    readonly popupProps: PropType<Record<string, any>>;
    /**
     * Custom popup node wrapper.
     * The basic DOM structure is `<Floating/> -> <Popup/> -> <PopupContent/>`.
     */
    readonly popupWrapper: PropType<(popup: VNode | null) => VNode>;
    /**
     * Custom floating node wrapper.
     * The basic DOM structure is `<Floating/> -> <Popup/> -> <PopupContent/>`.
     */
    readonly floatingWrapper: PropType<(popup: VNode | null) => VNode>;
    /**
     * Popup z-index.
     */
    readonly zIndex: NumberConstructor;
    readonly onFloatingDataUpdate: PropType<(data: {
        x: number | null;
        y: number | null;
        strategy: _floating_ui_core.Strategy;
        placement: _floating_ui_core.Placement;
        middlewareData: {
            [x: string]: any;
            arrow?: {
                x?: number | undefined;
                y?: number | undefined;
                centerOffset: number;
            } | undefined;
            autoPlacement?: {
                index?: number | undefined;
                overflows: {
                    placement: _floating_ui_core.Placement;
                    overflows: number[];
                }[];
            } | undefined;
            flip?: {
                index?: number | undefined;
                overflows: {
                    placement: _floating_ui_core.Placement;
                    overflows: number[];
                }[];
            } | undefined;
            hide?: {
                referenceHidden?: boolean | undefined;
                escaped?: boolean | undefined;
                referenceHiddenOffsets?: {
                    top: number;
                    right: number;
                    bottom: number;
                    left: number;
                } | undefined;
                escapedOffsets?: {
                    top: number;
                    right: number;
                    bottom: number;
                    left: number;
                } | undefined;
            } | undefined;
            offset?: {
                x: number;
                y: number;
            } | undefined;
            shift?: {
                x: number;
                y: number;
            } | undefined;
        };
    }) => void>;
    readonly floating: {
        type: PropType<HTMLElement | null>;
    };
    readonly reference: {
        type: PropType<ReferenceType$1 | null>;
    };
    readonly placement: Omit<{
        type: new (...args: any[]) => _floating_ui_core.Placement & {};
    } | {
        type: () => _floating_ui_core.Placement;
    } | {
        type: ((new (...args: any[]) => _floating_ui_core.Placement & {}) | (() => _floating_ui_core.Placement))[];
    }, "default"> & {
        default: "bottom";
    };
    readonly strategy: Omit<{
        type: new (...args: any[]) => _floating_ui_core.Strategy & {};
    } | {
        type: () => _floating_ui_core.Strategy;
    } | {
        type: ((new (...args: any[]) => _floating_ui_core.Strategy & {}) | (() => _floating_ui_core.Strategy))[];
    }, "default"> & {
        default: "absolute";
    };
    readonly middleware: PropType<_floating_ui_core.Middleware[]>;
    readonly autoUpdate: Omit<{
        type: new (...args: any[]) => (boolean | _visoning_vue_floating_core.UseAutoUpdateOptions) & {};
    } | {
        type: () => boolean | _visoning_vue_floating_core.UseAutoUpdateOptions;
    } | {
        type: ((new (...args: any[]) => (boolean | _visoning_vue_floating_core.UseAutoUpdateOptions) & {}) | (() => boolean | _visoning_vue_floating_core.UseAutoUpdateOptions))[];
    }, "default"> & {
        default: true;
    };
};
declare const PopupDefaultProps: {
    readonly appendTo: "body";
    readonly shift: true;
    readonly placement: "bottom";
    readonly strategy: "absolute";
    readonly autoUpdate: true;
};
declare const PopupProps: _visoning_vue_utility.WithDefaultProps<{
    /**
     * Whether to open popup.
     */
    readonly open: BooleanConstructor;
    /**
     * Whether to disable the floating.
     */
    readonly disabled: BooleanConstructor;
    /**
     * You can position a floating element relative to a virtual element instead of a real one.
     * This enables things like positioning context menus or following the cursor.
     * @see https://floating-ui.com/docs/virtual-elements
     */
    readonly virtualElement: PropType<VirtualElement$1>;
    /**
     * When this value is `true`, popup will be teleport to the target.
     * The teleport to target must be already in the DOM when the <Teleport> component is mounted.
     * @see https://vuejs.org/guide/built-ins/teleport.html
     *
     * Or you can customize the teleport logic, set `appendTo` to false, and use `floatingWrapper`,
     * for simple example
     * ```tsx
     * {
     *   appendTo: false,
     *   floatingWrapper: (floating) => h(
     *    Teleport,
     *    {
     *      to: anyTarget
     *    },
     *    {
     *      default: () => [floating]
     *    }
     *   )
     * }
     * ```
     * @default 'body'
     */
    readonly appendTo: PropType<string | false | HTMLElement>;
    /**
     * When this value is `false`, even if the popup is closed, floating will update the position as needed,
     * unless popup is disabled.
     */
    readonly autoUpdateOnClosed: BooleanConstructor;
    /**
     * Displaces the popup element from its core placement along the specified axes.
     * @see https://floating-ui.com/docs/offset
     */
    readonly offset: PropType<OffsetOptions>;
    /**
     * Moves the popup element along the specified axes in order to keep it in view.
     * @default true
     * @see https://floating-ui.com/docs/shift
     */
    readonly shift: PropType<boolean | ShiftOptions>;
    /**
     * Changes the placement of the popup element to the opposite one by default in order to keep it in view.
     * @see https://floating-ui.com/docs/flip
     */
    readonly flip: PropType<boolean | FlipOptions>;
    /**
     * Chooses the placement that has the most space available automatically.
     *
     * You’ll want to use this instead of `flip` if you don't want to give the popup element a “preferred” placement
     * and let it choose a placement for you.
     * @see https://floating-ui.com/docs/autoPlacement
     */
    readonly autoPlacement: PropType<boolean | AutoPlacementOptions>;
    /**
     * This determines whether GPU-accelerated styles are used to position the popup.
     * When this value is `true`, popup will use the 3D transforms.
     * When this value is `false`, popup will use top/left properties.
     */
    readonly gpuAcceleration: BooleanConstructor;
    /**
     * Whether destroy popup when closed.
     */
    readonly destoryedOnClosed: BooleanConstructor;
    /**
     * HTML attributes of node.
     */
    readonly referenceProps: PropType<Record<string, any>>;
    /**
     * HTML attributes of node.
     */
    readonly popupProps: PropType<Record<string, any>>;
    /**
     * Custom popup node wrapper.
     * The basic DOM structure is `<Floating/> -> <Popup/> -> <PopupContent/>`.
     */
    readonly popupWrapper: PropType<(popup: VNode | null) => VNode>;
    /**
     * Custom floating node wrapper.
     * The basic DOM structure is `<Floating/> -> <Popup/> -> <PopupContent/>`.
     */
    readonly floatingWrapper: PropType<(popup: VNode | null) => VNode>;
    /**
     * Popup z-index.
     */
    readonly zIndex: NumberConstructor;
    readonly onFloatingDataUpdate: PropType<(data: {
        x: number | null;
        y: number | null;
        strategy: _floating_ui_core.Strategy;
        placement: _floating_ui_core.Placement;
        middlewareData: {
            [x: string]: any;
            arrow?: {
                x?: number | undefined;
                y?: number | undefined;
                centerOffset: number;
            } | undefined;
            autoPlacement?: {
                index?: number | undefined;
                overflows: {
                    placement: _floating_ui_core.Placement;
                    overflows: number[];
                }[];
            } | undefined;
            flip?: {
                index?: number | undefined;
                overflows: {
                    placement: _floating_ui_core.Placement;
                    overflows: number[];
                }[];
            } | undefined;
            hide?: {
                referenceHidden?: boolean | undefined;
                escaped?: boolean | undefined;
                referenceHiddenOffsets?: {
                    top: number;
                    right: number;
                    bottom: number;
                    left: number;
                } | undefined;
                escapedOffsets?: {
                    top: number;
                    right: number;
                    bottom: number;
                    left: number;
                } | undefined;
            } | undefined;
            offset?: {
                x: number;
                y: number;
            } | undefined;
            shift?: {
                x: number;
                y: number;
            } | undefined;
        };
    }) => void>;
    readonly floating: {
        type: PropType<HTMLElement | null>;
    };
    readonly reference: {
        type: PropType<ReferenceType$1 | null>;
    };
    readonly placement: Omit<{
        type: new (...args: any[]) => _floating_ui_core.Placement & {};
    } | {
        type: () => _floating_ui_core.Placement;
    } | {
        type: ((new (...args: any[]) => _floating_ui_core.Placement & {}) | (() => _floating_ui_core.Placement))[];
    }, "default"> & {
        default: "bottom";
    };
    readonly strategy: Omit<{
        type: new (...args: any[]) => _floating_ui_core.Strategy & {};
    } | {
        type: () => _floating_ui_core.Strategy;
    } | {
        type: ((new (...args: any[]) => _floating_ui_core.Strategy & {}) | (() => _floating_ui_core.Strategy))[];
    }, "default"> & {
        default: "absolute";
    };
    readonly middleware: PropType<_floating_ui_core.Middleware[]>;
    readonly autoUpdate: Omit<{
        type: new (...args: any[]) => (boolean | _visoning_vue_floating_core.UseAutoUpdateOptions) & {};
    } | {
        type: () => boolean | _visoning_vue_floating_core.UseAutoUpdateOptions;
    } | {
        type: ((new (...args: any[]) => (boolean | _visoning_vue_floating_core.UseAutoUpdateOptions) & {}) | (() => boolean | _visoning_vue_floating_core.UseAutoUpdateOptions))[];
    }, "default"> & {
        default: true;
    };
}, {
    readonly appendTo: "body";
    readonly shift: true;
    readonly placement: "bottom";
    readonly strategy: "absolute";
    readonly autoUpdate: true;
}>;
declare type PopupProps = ExtractPropTypes<typeof PopupProps>;

declare type ForwardReferenceType = ReferenceType$1 | undefined;
interface ForwardReferenceContextValue {
    forwardReference: (reference: ForwardReferenceType) => void;
}
declare const useSafeReferenceForwardContent: () => ForwardReferenceContextValue | undefined;
declare const useReferenceForwardContext: () => ForwardReferenceContextValue;
declare const providePopupContextValue: (contextValue: ForwardReferenceContextValue) => void;
declare const createReferenceForwardContext: (referenceRef?: Ref<ForwardReferenceType>) => Ref<ForwardReferenceType>;

interface PopoverExposed extends PopupExposed {
}
declare type PopoverArrowSlotProps = PopupSlotProps;
declare type CreateArrow = (props: PopoverArrowSlotProps) => VNode | null;
declare type Interaction = 'click' | 'hover' | 'focus';
declare const PopoverPropsType: {
    /**
     * Default open when not manually set.
     */
    readonly defaultOpen: BooleanConstructor;
    /**
     * Which actions cause popup shown. enum of 'hover','click','focus'.
     */
    readonly interactions: PropType<Interaction[]>;
    /**
     * Common delay in ms, before popup is open/close.
     */
    readonly delay: PropType<number>;
    /**
     * Delay in ms, before popup is open/close on pointer click.
     */
    readonly clickDelay: PropType<number>;
    /**
     * Delay in ms, before popup is open/close on pointer enter/leave.
     */
    readonly hoverDelay: PropType<number>;
    /**
     * Delay in ms, before popup is open/close on focus/blur.
     */
    readonly focusDelay: PropType<number>;
    /**
     * Whether to keep the popup open on mouse hover
     */
    readonly keepOpenWhenPopupHover: BooleanConstructor;
    /**
     * Whether to close by clicking outside.
     * @default true
     */
    readonly closeWhenClickOutside: BooleanConstructor;
    /**
     * support: string | () => VNode | slot
     */
    readonly content: PropType<string | (() => VNode)>;
    /**
     * support: string | () => VNode | slot
     */
    readonly title: PropType<string | (() => VNode)>;
    /**
     * The theme of the popover.
     * @default 'light'
     */
    readonly theme: PropType<"dark" | "light">;
    /**
     * The size of the popover.
     * @default 'meduim'
     */
    readonly size: PropType<"small" | "meduim">;
    /**
     * @see https://cn.vuejs.org/guide/built-ins/transition.html
     */
    readonly transitionProps: PropType<string | Record<string, any>>;
    /**
     * Whether to show arrow if set.
     * @default true
     */
    readonly showArrow: BooleanConstructor;
    /**
     * For style uniformity, we will never enable the configuration of arrow middleware,
     * you can customize arrow to make arrow more as expected.
     *
     * support: CreateArrow | slot
     */
    readonly arrow: PropType<CreateArrow>;
    /**
     * HTML attributes of node.
     */
    readonly arrowProps: PropType<Record<string, any>>;
    /**
     * HTML attributes of popover node.
     */
    readonly popoverProps: PropType<Record<string, any>>;
    /**
     * HTML attributes of popover-content node.
     */
    readonly contentProps: PropType<Record<string, any>>;
    /**
     * Custom popover node wrapper.
     */
    readonly popoverWrapper: PropType<(popup: VNode<vue_demi.RendererNode, vue_demi.RendererElement, {
        [key: string]: any;
    }> | null) => VNode<vue_demi.RendererNode, vue_demi.RendererElement, {
        [key: string]: any;
    }>>;
    /**
     * Callback on open status changes.
     */
    readonly 'onUpdate:open': PropType<(open: boolean, info: InteractionInfo$1) => void>;
    /**
     * Callback on popup open.
     */
    readonly onOpen: PropType<(info: InteractionInfo$1) => void>;
    /**
     * Callback on popup close.
     */
    readonly onClose: PropType<(info: InteractionInfo$1) => void>;
    readonly onFloatingDataUpdate: PropType<(data: {
        x: number | null;
        y: number | null;
        strategy: _floating_ui_core.Strategy;
        placement: _floating_ui_core.Placement;
        middlewareData: {
            [x: string]: any;
            arrow?: {
                x?: number | undefined;
                y?: number | undefined;
                centerOffset: number;
            } | undefined;
            autoPlacement?: {
                index?: number | undefined;
                overflows: {
                    placement: _floating_ui_core.Placement;
                    overflows: number[];
                }[];
            } | undefined;
            flip?: {
                index?: number | undefined;
                overflows: {
                    placement: _floating_ui_core.Placement;
                    overflows: number[];
                }[];
            } | undefined;
            hide?: {
                referenceHidden?: boolean | undefined;
                escaped?: boolean | undefined;
                referenceHiddenOffsets?: {
                    top: number;
                    right: number;
                    bottom: number;
                    left: number;
                } | undefined;
                escapedOffsets?: {
                    top: number;
                    right: number;
                    bottom: number;
                    left: number;
                } | undefined;
            } | undefined;
            offset?: {
                x: number;
                y: number;
            } | undefined;
            shift?: {
                x: number;
                y: number;
            } | undefined;
        };
    }) => void>;
    readonly open: BooleanConstructor;
    readonly shift: Omit<{
        type: new (...args: any[]) => (boolean | _floating_ui_core.ShiftOptions) & {};
    } | {
        type: () => boolean | _floating_ui_core.ShiftOptions;
    } | {
        type: ((new (...args: any[]) => (boolean | _floating_ui_core.ShiftOptions) & {}) | (() => boolean | _floating_ui_core.ShiftOptions))[];
    }, "default"> & {
        default: true;
    };
    readonly disabled: BooleanConstructor;
    readonly floating: {
        type: PropType<HTMLElement | null>;
    };
    readonly reference: {
        type: PropType<ReferenceType | null>;
    };
    readonly placement: Omit<Omit<{
        type: new (...args: any[]) => _floating_ui_core.Placement & {};
    } | {
        type: () => _floating_ui_core.Placement;
    } | {
        type: ((new (...args: any[]) => _floating_ui_core.Placement & {}) | (() => _floating_ui_core.Placement))[];
    }, "default"> & {
        default: "bottom";
    }, "default"> & {
        default: "bottom";
    };
    readonly strategy: Omit<Omit<{
        type: new (...args: any[]) => _floating_ui_core.Strategy & {};
    } | {
        type: () => _floating_ui_core.Strategy;
    } | {
        type: ((new (...args: any[]) => _floating_ui_core.Strategy & {}) | (() => _floating_ui_core.Strategy))[];
    }, "default"> & {
        default: "absolute";
    }, "default"> & {
        default: "absolute";
    };
    readonly middleware: PropType<_floating_ui_core.Middleware[]>;
    readonly autoPlacement: PropType<boolean | _floating_ui_core.AutoPlacementOptions>;
    readonly flip: PropType<boolean | _floating_ui_core.FlipOptions>;
    readonly offset: PropType<_floating_ui_core.OffsetOptions>;
    readonly autoUpdate: Omit<Omit<{
        type: new (...args: any[]) => (boolean | UseAutoUpdateOptions) & {};
    } | {
        type: () => boolean | UseAutoUpdateOptions;
    } | {
        type: ((new (...args: any[]) => (boolean | UseAutoUpdateOptions) & {}) | (() => boolean | UseAutoUpdateOptions))[];
    }, "default"> & {
        default: true;
    }, "default"> & {
        default: true;
    };
    readonly virtualElement: PropType<_floating_ui_dom.VirtualElement>;
    readonly appendTo: Omit<{
        type: new (...args: any[]) => (string | false | HTMLElement) & {};
    } | {
        type: () => string | false | HTMLElement;
    } | {
        type: ((new (...args: any[]) => (string | false | HTMLElement) & {}) | (() => string | false | HTMLElement))[];
    }, "default"> & {
        default: "body";
    };
    readonly autoUpdateOnClosed: BooleanConstructor;
    readonly gpuAcceleration: BooleanConstructor;
    readonly destoryedOnClosed: BooleanConstructor;
    readonly referenceProps: PropType<Record<string, any>>;
    readonly popupProps: PropType<Record<string, any>>;
    readonly popupWrapper: PropType<(popup: VNode<vue_demi.RendererNode, vue_demi.RendererElement, {
        [key: string]: any;
    }> | null) => VNode<vue_demi.RendererNode, vue_demi.RendererElement, {
        [key: string]: any;
    }>>;
    readonly floatingWrapper: PropType<(popup: VNode<vue_demi.RendererNode, vue_demi.RendererElement, {
        [key: string]: any;
    }> | null) => VNode<vue_demi.RendererNode, vue_demi.RendererElement, {
        [key: string]: any;
    }>>;
    readonly zIndex: NumberConstructor;
};
declare const PopoverTransitionName = "visoning-popover";
declare const PopoverDefaultProps: {
    readonly open: undefined;
    readonly interactions: () => string[];
    readonly keepOpenWhenPopupHover: true;
    readonly closeWhenClickOutside: true;
    readonly theme: "line";
    readonly size: "meduim";
    readonly transitionProps: "visoning-popover";
    readonly showArrow: true;
    readonly appendTo: "body";
    readonly shift: true;
    readonly placement: "bottom";
    readonly strategy: "absolute";
    readonly autoUpdate: true;
};
declare const PopoverProps: _visoning_vue_utility.WithDefaultProps<{
    /**
     * Default open when not manually set.
     */
    readonly defaultOpen: BooleanConstructor;
    /**
     * Which actions cause popup shown. enum of 'hover','click','focus'.
     */
    readonly interactions: PropType<Interaction[]>;
    /**
     * Common delay in ms, before popup is open/close.
     */
    readonly delay: PropType<number>;
    /**
     * Delay in ms, before popup is open/close on pointer click.
     */
    readonly clickDelay: PropType<number>;
    /**
     * Delay in ms, before popup is open/close on pointer enter/leave.
     */
    readonly hoverDelay: PropType<number>;
    /**
     * Delay in ms, before popup is open/close on focus/blur.
     */
    readonly focusDelay: PropType<number>;
    /**
     * Whether to keep the popup open on mouse hover
     */
    readonly keepOpenWhenPopupHover: BooleanConstructor;
    /**
     * Whether to close by clicking outside.
     * @default true
     */
    readonly closeWhenClickOutside: BooleanConstructor;
    /**
     * support: string | () => VNode | slot
     */
    readonly content: PropType<string | (() => VNode)>;
    /**
     * support: string | () => VNode | slot
     */
    readonly title: PropType<string | (() => VNode)>;
    /**
     * The theme of the popover.
     * @default 'light'
     */
    readonly theme: PropType<"dark" | "light">;
    /**
     * The size of the popover.
     * @default 'meduim'
     */
    readonly size: PropType<"small" | "meduim">;
    /**
     * @see https://cn.vuejs.org/guide/built-ins/transition.html
     */
    readonly transitionProps: PropType<string | Record<string, any>>;
    /**
     * Whether to show arrow if set.
     * @default true
     */
    readonly showArrow: BooleanConstructor;
    /**
     * For style uniformity, we will never enable the configuration of arrow middleware,
     * you can customize arrow to make arrow more as expected.
     *
     * support: CreateArrow | slot
     */
    readonly arrow: PropType<CreateArrow>;
    /**
     * HTML attributes of node.
     */
    readonly arrowProps: PropType<Record<string, any>>;
    /**
     * HTML attributes of popover node.
     */
    readonly popoverProps: PropType<Record<string, any>>;
    /**
     * HTML attributes of popover-content node.
     */
    readonly contentProps: PropType<Record<string, any>>;
    /**
     * Custom popover node wrapper.
     */
    readonly popoverWrapper: PropType<(popup: VNode<vue_demi.RendererNode, vue_demi.RendererElement, {
        [key: string]: any;
    }> | null) => VNode<vue_demi.RendererNode, vue_demi.RendererElement, {
        [key: string]: any;
    }>>;
    /**
     * Callback on open status changes.
     */
    readonly 'onUpdate:open': PropType<(open: boolean, info: InteractionInfo$1) => void>;
    /**
     * Callback on popup open.
     */
    readonly onOpen: PropType<(info: InteractionInfo$1) => void>;
    /**
     * Callback on popup close.
     */
    readonly onClose: PropType<(info: InteractionInfo$1) => void>;
    readonly onFloatingDataUpdate: PropType<(data: {
        x: number | null;
        y: number | null;
        strategy: _floating_ui_core.Strategy;
        placement: _floating_ui_core.Placement;
        middlewareData: {
            [x: string]: any;
            arrow?: {
                x?: number | undefined;
                y?: number | undefined;
                centerOffset: number;
            } | undefined;
            autoPlacement?: {
                index?: number | undefined;
                overflows: {
                    placement: _floating_ui_core.Placement;
                    overflows: number[];
                }[];
            } | undefined;
            flip?: {
                index?: number | undefined;
                overflows: {
                    placement: _floating_ui_core.Placement;
                    overflows: number[];
                }[];
            } | undefined;
            hide?: {
                referenceHidden?: boolean | undefined;
                escaped?: boolean | undefined;
                referenceHiddenOffsets?: {
                    top: number;
                    right: number;
                    bottom: number;
                    left: number;
                } | undefined;
                escapedOffsets?: {
                    top: number;
                    right: number;
                    bottom: number;
                    left: number;
                } | undefined;
            } | undefined;
            offset?: {
                x: number;
                y: number;
            } | undefined;
            shift?: {
                x: number;
                y: number;
            } | undefined;
        };
    }) => void>;
    readonly open: BooleanConstructor;
    readonly shift: Omit<{
        type: new (...args: any[]) => (boolean | _floating_ui_core.ShiftOptions) & {};
    } | {
        type: () => boolean | _floating_ui_core.ShiftOptions;
    } | {
        type: ((new (...args: any[]) => (boolean | _floating_ui_core.ShiftOptions) & {}) | (() => boolean | _floating_ui_core.ShiftOptions))[];
    }, "default"> & {
        default: true;
    };
    readonly disabled: BooleanConstructor;
    readonly floating: {
        type: PropType<HTMLElement | null>;
    };
    readonly reference: {
        type: PropType<ReferenceType | null>;
    };
    readonly placement: Omit<Omit<{
        type: new (...args: any[]) => _floating_ui_core.Placement & {};
    } | {
        type: () => _floating_ui_core.Placement;
    } | {
        type: ((new (...args: any[]) => _floating_ui_core.Placement & {}) | (() => _floating_ui_core.Placement))[];
    }, "default"> & {
        default: "bottom";
    }, "default"> & {
        default: "bottom";
    };
    readonly strategy: Omit<Omit<{
        type: new (...args: any[]) => _floating_ui_core.Strategy & {};
    } | {
        type: () => _floating_ui_core.Strategy;
    } | {
        type: ((new (...args: any[]) => _floating_ui_core.Strategy & {}) | (() => _floating_ui_core.Strategy))[];
    }, "default"> & {
        default: "absolute";
    }, "default"> & {
        default: "absolute";
    };
    readonly middleware: PropType<_floating_ui_core.Middleware[]>;
    readonly autoPlacement: PropType<boolean | _floating_ui_core.AutoPlacementOptions>;
    readonly flip: PropType<boolean | _floating_ui_core.FlipOptions>;
    readonly offset: PropType<_floating_ui_core.OffsetOptions>;
    readonly autoUpdate: Omit<Omit<{
        type: new (...args: any[]) => (boolean | UseAutoUpdateOptions) & {};
    } | {
        type: () => boolean | UseAutoUpdateOptions;
    } | {
        type: ((new (...args: any[]) => (boolean | UseAutoUpdateOptions) & {}) | (() => boolean | UseAutoUpdateOptions))[];
    }, "default"> & {
        default: true;
    }, "default"> & {
        default: true;
    };
    readonly virtualElement: PropType<_floating_ui_dom.VirtualElement>;
    readonly appendTo: Omit<{
        type: new (...args: any[]) => (string | false | HTMLElement) & {};
    } | {
        type: () => string | false | HTMLElement;
    } | {
        type: ((new (...args: any[]) => (string | false | HTMLElement) & {}) | (() => string | false | HTMLElement))[];
    }, "default"> & {
        default: "body";
    };
    readonly autoUpdateOnClosed: BooleanConstructor;
    readonly gpuAcceleration: BooleanConstructor;
    readonly destoryedOnClosed: BooleanConstructor;
    readonly referenceProps: PropType<Record<string, any>>;
    readonly popupProps: PropType<Record<string, any>>;
    readonly popupWrapper: PropType<(popup: VNode<vue_demi.RendererNode, vue_demi.RendererElement, {
        [key: string]: any;
    }> | null) => VNode<vue_demi.RendererNode, vue_demi.RendererElement, {
        [key: string]: any;
    }>>;
    readonly floatingWrapper: PropType<(popup: VNode<vue_demi.RendererNode, vue_demi.RendererElement, {
        [key: string]: any;
    }> | null) => VNode<vue_demi.RendererNode, vue_demi.RendererElement, {
        [key: string]: any;
    }>>;
    readonly zIndex: NumberConstructor;
}, {
    readonly open: undefined;
    readonly interactions: () => string[];
    readonly keepOpenWhenPopupHover: true;
    readonly closeWhenClickOutside: true;
    readonly theme: "line";
    readonly size: "meduim";
    readonly transitionProps: "visoning-popover";
    readonly showArrow: true;
    readonly appendTo: "body";
    readonly shift: true;
    readonly placement: "bottom";
    readonly strategy: "absolute";
    readonly autoUpdate: true;
}>;
declare type PopoverProps = ExtractPropTypes<typeof PopoverProps>;

declare const Popover: Vue3.DefineComponent<_visoning_vue_utility.WithDefaultProps<{
    readonly defaultOpen: BooleanConstructor;
    readonly interactions: Vue3.PropType<Interaction[]>;
    readonly delay: Vue3.PropType<number>;
    readonly clickDelay: Vue3.PropType<number>;
    readonly hoverDelay: Vue3.PropType<number>;
    readonly focusDelay: Vue3.PropType<number>;
    readonly keepOpenWhenPopupHover: BooleanConstructor;
    readonly closeWhenClickOutside: BooleanConstructor;
    readonly content: Vue3.PropType<string | (() => Vue3.VNode<Vue3.RendererNode, Vue3.RendererElement, {
        [key: string]: any;
    }>)>;
    readonly title: Vue3.PropType<string | (() => Vue3.VNode<Vue3.RendererNode, Vue3.RendererElement, {
        [key: string]: any;
    }>)>;
    readonly theme: Vue3.PropType<"dark" | "light">;
    readonly size: Vue3.PropType<"small" | "meduim">;
    readonly transitionProps: Vue3.PropType<string | Record<string, any>>;
    readonly showArrow: BooleanConstructor;
    readonly arrow: Vue3.PropType<CreateArrow>;
    readonly arrowProps: Vue3.PropType<Record<string, any>>;
    readonly popoverProps: Vue3.PropType<Record<string, any>>;
    readonly contentProps: Vue3.PropType<Record<string, any>>;
    readonly popoverWrapper: Vue3.PropType<(popup: Vue3.VNode<Vue3.RendererNode, Vue3.RendererElement, {
        [key: string]: any;
    }> | null) => Vue3.VNode<Vue3.RendererNode, Vue3.RendererElement, {
        [key: string]: any;
    }>>;
    readonly 'onUpdate:open': Vue3.PropType<(open: boolean, info: InteractionInfo$1) => void>;
    readonly onOpen: Vue3.PropType<(info: InteractionInfo$1) => void>;
    readonly onClose: Vue3.PropType<(info: InteractionInfo$1) => void>;
    readonly onFloatingDataUpdate: Vue3.PropType<(data: {
        x: number | null;
        y: number | null;
        strategy: _floating_ui_core.Strategy;
        placement: _floating_ui_core.Placement;
        middlewareData: {
            [x: string]: any;
            arrow?: {
                x?: number | undefined;
                y?: number | undefined;
                centerOffset: number;
            } | undefined;
            autoPlacement?: {
                index?: number | undefined;
                overflows: {
                    placement: _floating_ui_core.Placement;
                    overflows: number[];
                }[];
            } | undefined;
            flip?: {
                index?: number | undefined;
                overflows: {
                    placement: _floating_ui_core.Placement;
                    overflows: number[];
                }[];
            } | undefined;
            hide?: {
                referenceHidden?: boolean | undefined;
                escaped?: boolean | undefined;
                referenceHiddenOffsets?: {
                    top: number;
                    right: number;
                    bottom: number;
                    left: number;
                } | undefined;
                escapedOffsets?: {
                    top: number;
                    right: number;
                    bottom: number;
                    left: number;
                } | undefined;
            } | undefined;
            offset?: {
                x: number;
                y: number;
            } | undefined;
            shift?: {
                x: number;
                y: number;
            } | undefined;
        };
    }) => void>;
    readonly open: BooleanConstructor;
    readonly shift: Omit<{
        type: new (...args: any[]) => (boolean | _floating_ui_core.ShiftOptions) & {};
    } | {
        type: () => boolean | _floating_ui_core.ShiftOptions;
    } | {
        type: ((new (...args: any[]) => (boolean | _floating_ui_core.ShiftOptions) & {}) | (() => boolean | _floating_ui_core.ShiftOptions))[];
    }, "default"> & {
        default: true;
    };
    readonly disabled: BooleanConstructor;
    readonly floating: {
        type: Vue3.PropType<HTMLElement | null>;
    };
    readonly reference: {
        type: Vue3.PropType<ReferenceType | null>;
    };
    readonly placement: Omit<Omit<{
        type: new (...args: any[]) => _floating_ui_core.Placement & {};
    } | {
        type: () => _floating_ui_core.Placement;
    } | {
        type: ((new (...args: any[]) => _floating_ui_core.Placement & {}) | (() => _floating_ui_core.Placement))[];
    }, "default"> & {
        default: "bottom";
    }, "default"> & {
        default: "bottom";
    };
    readonly strategy: Omit<Omit<{
        type: new (...args: any[]) => _floating_ui_core.Strategy & {};
    } | {
        type: () => _floating_ui_core.Strategy;
    } | {
        type: ((new (...args: any[]) => _floating_ui_core.Strategy & {}) | (() => _floating_ui_core.Strategy))[];
    }, "default"> & {
        default: "absolute";
    }, "default"> & {
        default: "absolute";
    };
    readonly middleware: Vue3.PropType<_floating_ui_core.Middleware[]>;
    readonly autoPlacement: Vue3.PropType<boolean | _floating_ui_core.AutoPlacementOptions>;
    readonly flip: Vue3.PropType<boolean | _floating_ui_core.FlipOptions>;
    readonly offset: Vue3.PropType<_floating_ui_core.OffsetOptions>;
    readonly autoUpdate: Omit<Omit<{
        type: new (...args: any[]) => (boolean | UseAutoUpdateOptions) & {};
    } | {
        type: () => boolean | UseAutoUpdateOptions;
    } | {
        type: ((new (...args: any[]) => (boolean | UseAutoUpdateOptions) & {}) | (() => boolean | UseAutoUpdateOptions))[];
    }, "default"> & {
        default: true;
    }, "default"> & {
        default: true;
    };
    readonly virtualElement: Vue3.PropType<_floating_ui_dom.VirtualElement>;
    readonly appendTo: Omit<{
        type: new (...args: any[]) => (string | false | HTMLElement) & {};
    } | {
        type: () => string | false | HTMLElement;
    } | {
        type: ((new (...args: any[]) => (string | false | HTMLElement) & {}) | (() => string | false | HTMLElement))[];
    }, "default"> & {
        default: "body";
    };
    readonly autoUpdateOnClosed: BooleanConstructor;
    readonly gpuAcceleration: BooleanConstructor;
    readonly destoryedOnClosed: BooleanConstructor;
    readonly referenceProps: Vue3.PropType<Record<string, any>>;
    readonly popupProps: Vue3.PropType<Record<string, any>>;
    readonly popupWrapper: Vue3.PropType<(popup: Vue3.VNode<Vue3.RendererNode, Vue3.RendererElement, {
        [key: string]: any;
    }> | null) => Vue3.VNode<Vue3.RendererNode, Vue3.RendererElement, {
        [key: string]: any;
    }>>;
    readonly floatingWrapper: Vue3.PropType<(popup: Vue3.VNode<Vue3.RendererNode, Vue3.RendererElement, {
        [key: string]: any;
    }> | null) => Vue3.VNode<Vue3.RendererNode, Vue3.RendererElement, {
        [key: string]: any;
    }>>;
    readonly zIndex: NumberConstructor;
}, {
    readonly open: undefined;
    readonly interactions: () => string[];
    readonly keepOpenWhenPopupHover: true;
    readonly closeWhenClickOutside: true;
    readonly theme: "line";
    readonly size: "meduim";
    readonly transitionProps: "visoning-popover";
    readonly showArrow: true;
    readonly appendTo: "body";
    readonly shift: true;
    readonly placement: "bottom";
    readonly strategy: "absolute";
    readonly autoUpdate: true;
}>, () => Vue3.VNode<Vue3.RendererNode, Vue3.RendererElement, {
    [key: string]: any;
}>, unknown, {}, {}, Vue3.ComponentOptionsMixin, Vue3.ComponentOptionsMixin, {}, string, Vue3.VNodeProps & Vue3.AllowedComponentProps & Vue3.ComponentCustomProps, Readonly<Vue3.ExtractPropTypes<_visoning_vue_utility.WithDefaultProps<{
    readonly defaultOpen: BooleanConstructor;
    readonly interactions: Vue3.PropType<Interaction[]>;
    readonly delay: Vue3.PropType<number>;
    readonly clickDelay: Vue3.PropType<number>;
    readonly hoverDelay: Vue3.PropType<number>;
    readonly focusDelay: Vue3.PropType<number>;
    readonly keepOpenWhenPopupHover: BooleanConstructor;
    readonly closeWhenClickOutside: BooleanConstructor;
    readonly content: Vue3.PropType<string | (() => Vue3.VNode<Vue3.RendererNode, Vue3.RendererElement, {
        [key: string]: any;
    }>)>;
    readonly title: Vue3.PropType<string | (() => Vue3.VNode<Vue3.RendererNode, Vue3.RendererElement, {
        [key: string]: any;
    }>)>;
    readonly theme: Vue3.PropType<"dark" | "light">;
    readonly size: Vue3.PropType<"small" | "meduim">;
    readonly transitionProps: Vue3.PropType<string | Record<string, any>>;
    readonly showArrow: BooleanConstructor;
    readonly arrow: Vue3.PropType<CreateArrow>;
    readonly arrowProps: Vue3.PropType<Record<string, any>>;
    readonly popoverProps: Vue3.PropType<Record<string, any>>;
    readonly contentProps: Vue3.PropType<Record<string, any>>;
    readonly popoverWrapper: Vue3.PropType<(popup: Vue3.VNode<Vue3.RendererNode, Vue3.RendererElement, {
        [key: string]: any;
    }> | null) => Vue3.VNode<Vue3.RendererNode, Vue3.RendererElement, {
        [key: string]: any;
    }>>;
    readonly 'onUpdate:open': Vue3.PropType<(open: boolean, info: InteractionInfo$1) => void>;
    readonly onOpen: Vue3.PropType<(info: InteractionInfo$1) => void>;
    readonly onClose: Vue3.PropType<(info: InteractionInfo$1) => void>;
    readonly onFloatingDataUpdate: Vue3.PropType<(data: {
        x: number | null;
        y: number | null;
        strategy: _floating_ui_core.Strategy;
        placement: _floating_ui_core.Placement;
        middlewareData: {
            [x: string]: any;
            arrow?: {
                x?: number | undefined;
                y?: number | undefined;
                centerOffset: number;
            } | undefined;
            autoPlacement?: {
                index?: number | undefined;
                overflows: {
                    placement: _floating_ui_core.Placement;
                    overflows: number[];
                }[];
            } | undefined;
            flip?: {
                index?: number | undefined;
                overflows: {
                    placement: _floating_ui_core.Placement;
                    overflows: number[];
                }[];
            } | undefined;
            hide?: {
                referenceHidden?: boolean | undefined;
                escaped?: boolean | undefined;
                referenceHiddenOffsets?: {
                    top: number;
                    right: number;
                    bottom: number;
                    left: number;
                } | undefined;
                escapedOffsets?: {
                    top: number;
                    right: number;
                    bottom: number;
                    left: number;
                } | undefined;
            } | undefined;
            offset?: {
                x: number;
                y: number;
            } | undefined;
            shift?: {
                x: number;
                y: number;
            } | undefined;
        };
    }) => void>;
    readonly open: BooleanConstructor;
    readonly shift: Omit<{
        type: new (...args: any[]) => (boolean | _floating_ui_core.ShiftOptions) & {};
    } | {
        type: () => boolean | _floating_ui_core.ShiftOptions;
    } | {
        type: ((new (...args: any[]) => (boolean | _floating_ui_core.ShiftOptions) & {}) | (() => boolean | _floating_ui_core.ShiftOptions))[];
    }, "default"> & {
        default: true;
    };
    readonly disabled: BooleanConstructor;
    readonly floating: {
        type: Vue3.PropType<HTMLElement | null>;
    };
    readonly reference: {
        type: Vue3.PropType<ReferenceType | null>;
    };
    readonly placement: Omit<Omit<{
        type: new (...args: any[]) => _floating_ui_core.Placement & {};
    } | {
        type: () => _floating_ui_core.Placement;
    } | {
        type: ((new (...args: any[]) => _floating_ui_core.Placement & {}) | (() => _floating_ui_core.Placement))[];
    }, "default"> & {
        default: "bottom";
    }, "default"> & {
        default: "bottom";
    };
    readonly strategy: Omit<Omit<{
        type: new (...args: any[]) => _floating_ui_core.Strategy & {};
    } | {
        type: () => _floating_ui_core.Strategy;
    } | {
        type: ((new (...args: any[]) => _floating_ui_core.Strategy & {}) | (() => _floating_ui_core.Strategy))[];
    }, "default"> & {
        default: "absolute";
    }, "default"> & {
        default: "absolute";
    };
    readonly middleware: Vue3.PropType<_floating_ui_core.Middleware[]>;
    readonly autoPlacement: Vue3.PropType<boolean | _floating_ui_core.AutoPlacementOptions>;
    readonly flip: Vue3.PropType<boolean | _floating_ui_core.FlipOptions>;
    readonly offset: Vue3.PropType<_floating_ui_core.OffsetOptions>;
    readonly autoUpdate: Omit<Omit<{
        type: new (...args: any[]) => (boolean | UseAutoUpdateOptions) & {};
    } | {
        type: () => boolean | UseAutoUpdateOptions;
    } | {
        type: ((new (...args: any[]) => (boolean | UseAutoUpdateOptions) & {}) | (() => boolean | UseAutoUpdateOptions))[];
    }, "default"> & {
        default: true;
    }, "default"> & {
        default: true;
    };
    readonly virtualElement: Vue3.PropType<_floating_ui_dom.VirtualElement>;
    readonly appendTo: Omit<{
        type: new (...args: any[]) => (string | false | HTMLElement) & {};
    } | {
        type: () => string | false | HTMLElement;
    } | {
        type: ((new (...args: any[]) => (string | false | HTMLElement) & {}) | (() => string | false | HTMLElement))[];
    }, "default"> & {
        default: "body";
    };
    readonly autoUpdateOnClosed: BooleanConstructor;
    readonly gpuAcceleration: BooleanConstructor;
    readonly destoryedOnClosed: BooleanConstructor;
    readonly referenceProps: Vue3.PropType<Record<string, any>>;
    readonly popupProps: Vue3.PropType<Record<string, any>>;
    readonly popupWrapper: Vue3.PropType<(popup: Vue3.VNode<Vue3.RendererNode, Vue3.RendererElement, {
        [key: string]: any;
    }> | null) => Vue3.VNode<Vue3.RendererNode, Vue3.RendererElement, {
        [key: string]: any;
    }>>;
    readonly floatingWrapper: Vue3.PropType<(popup: Vue3.VNode<Vue3.RendererNode, Vue3.RendererElement, {
        [key: string]: any;
    }> | null) => Vue3.VNode<Vue3.RendererNode, Vue3.RendererElement, {
        [key: string]: any;
    }>>;
    readonly zIndex: NumberConstructor;
}, {
    readonly open: undefined;
    readonly interactions: () => string[];
    readonly keepOpenWhenPopupHover: true;
    readonly closeWhenClickOutside: true;
    readonly theme: "line";
    readonly size: "meduim";
    readonly transitionProps: "visoning-popover";
    readonly showArrow: true;
    readonly appendTo: "body";
    readonly shift: true;
    readonly placement: "bottom";
    readonly strategy: "absolute";
    readonly autoUpdate: true;
}>>>, {
    readonly open: boolean;
    readonly shift: boolean | _floating_ui_core.ShiftOptions;
    readonly disabled: boolean;
    readonly closeWhenClickOutside: boolean;
    readonly keepOpenWhenPopupHover: boolean;
    readonly placement: _floating_ui_core.Placement;
    readonly strategy: _floating_ui_core.Strategy;
    readonly autoUpdate: boolean | UseAutoUpdateOptions;
    readonly appendTo: string | false | HTMLElement;
    readonly autoUpdateOnClosed: boolean;
    readonly gpuAcceleration: boolean;
    readonly destoryedOnClosed: boolean;
    readonly defaultOpen: boolean;
    readonly interactions: Interaction[];
    readonly theme: "dark" | "light";
    readonly size: "small" | "meduim";
    readonly transitionProps: string | Record<string, any>;
    readonly showArrow: boolean;
}>;

/**
 * The info of action that finally sets open.
 */
interface InteractionInfo {
    type: string;
    event?: Event | null;
}

declare const Tooltip: vue_demi.DefineComponent<_visoning_vue_utility.WithDefaultProps<{
    readonly content: vue_demi.PropType<string | (() => vue_demi.VNode<vue_demi.RendererNode, vue_demi.RendererElement, {
        [key: string]: any;
    }>)>;
    readonly textAlign: vue_demi.PropType<"right" | "left" | "start" | "end" | "center" | "justify" | "match-parent">;
    readonly tooltipProps: vue_demi.PropType<Record<string, any>>;
    readonly tooltipWrapper: vue_demi.PropType<(popup: vue_demi.VNode<vue_demi.RendererNode, vue_demi.RendererElement, {
        [key: string]: any;
    }> | null) => vue_demi.VNode<vue_demi.RendererNode, vue_demi.RendererElement, {
        [key: string]: any;
    }>>;
    readonly onFloatingDataUpdate: vue_demi.PropType<(data: {
        x: number | null;
        y: number | null;
        strategy: _floating_ui_core.Strategy;
        placement: _floating_ui_core.Placement;
        middlewareData: {
            [x: string]: any;
            arrow?: {
                x?: number | undefined;
                y?: number | undefined;
                centerOffset: number;
            } | undefined;
            autoPlacement?: {
                index?: number | undefined;
                overflows: {
                    placement: _floating_ui_core.Placement;
                    overflows: number[];
                }[];
            } | undefined;
            flip?: {
                index?: number | undefined;
                overflows: {
                    placement: _floating_ui_core.Placement;
                    overflows: number[];
                }[];
            } | undefined;
            hide?: {
                referenceHidden?: boolean | undefined;
                escaped?: boolean | undefined;
                referenceHiddenOffsets?: {
                    top: number;
                    right: number;
                    bottom: number;
                    left: number;
                } | undefined;
                escapedOffsets?: {
                    top: number;
                    right: number;
                    bottom: number;
                    left: number;
                } | undefined;
            } | undefined;
            offset?: {
                x: number;
                y: number;
            } | undefined;
            shift?: {
                x: number;
                y: number;
            } | undefined;
        };
    }) => void>;
    readonly 'onUpdate:open': vue_demi.PropType<(open: boolean, info: InteractionInfo) => void>;
    readonly onOpen: vue_demi.PropType<(info: InteractionInfo) => void>;
    readonly onClose: vue_demi.PropType<(info: InteractionInfo) => void>;
    readonly open: Omit<{
        type: BooleanConstructor;
    }, "default"> & {
        default: undefined;
    };
    readonly delay: vue_demi.PropType<number>;
    readonly shift: Omit<Omit<{
        type: new (...args: any[]) => (boolean | _floating_ui_core.ShiftOptions) & {};
    } | {
        type: () => boolean | _floating_ui_core.ShiftOptions;
    } | {
        type: ((new (...args: any[]) => (boolean | _floating_ui_core.ShiftOptions) & {}) | (() => boolean | _floating_ui_core.ShiftOptions))[];
    }, "default"> & {
        default: true;
    }, "default"> & {
        default: true;
    };
    readonly disabled: BooleanConstructor;
    readonly closeWhenClickOutside: Omit<{
        type: BooleanConstructor;
    }, "default"> & {
        default: true;
    };
    readonly floating: {
        type: vue_demi.PropType<HTMLElement | null>;
    };
    readonly reference: {
        type: vue_demi.PropType<ReferenceType | null>;
    };
    readonly keepOpenWhenPopupHover: Omit<{
        type: BooleanConstructor;
    }, "default"> & {
        default: true;
    };
    readonly placement: Omit<Omit<Omit<{
        type: new (...args: any[]) => _floating_ui_core.Placement & {};
    } | {
        type: () => _floating_ui_core.Placement;
    } | {
        type: ((new (...args: any[]) => _floating_ui_core.Placement & {}) | (() => _floating_ui_core.Placement))[];
    }, "default"> & {
        default: "bottom";
    }, "default"> & {
        default: "bottom";
    }, "default"> & {
        default: "bottom";
    };
    readonly strategy: Omit<Omit<Omit<{
        type: new (...args: any[]) => _floating_ui_core.Strategy & {};
    } | {
        type: () => _floating_ui_core.Strategy;
    } | {
        type: ((new (...args: any[]) => _floating_ui_core.Strategy & {}) | (() => _floating_ui_core.Strategy))[];
    }, "default"> & {
        default: "absolute";
    }, "default"> & {
        default: "absolute";
    }, "default"> & {
        default: "absolute";
    };
    readonly middleware: vue_demi.PropType<_floating_ui_core.Middleware[]>;
    readonly arrow: vue_demi.PropType<CreateArrow>;
    readonly autoPlacement: vue_demi.PropType<boolean | _floating_ui_core.AutoPlacementOptions>;
    readonly flip: vue_demi.PropType<boolean | _floating_ui_core.FlipOptions>;
    readonly offset: vue_demi.PropType<_floating_ui_core.OffsetOptions>;
    readonly autoUpdate: Omit<Omit<Omit<{
        type: new (...args: any[]) => (boolean | UseAutoUpdateOptions) & {};
    } | {
        type: () => boolean | UseAutoUpdateOptions;
    } | {
        type: ((new (...args: any[]) => (boolean | UseAutoUpdateOptions) & {}) | (() => boolean | UseAutoUpdateOptions))[];
    }, "default"> & {
        default: true;
    }, "default"> & {
        default: true;
    }, "default"> & {
        default: true;
    };
    readonly virtualElement: vue_demi.PropType<_floating_ui_dom.VirtualElement>;
    readonly appendTo: Omit<Omit<{
        type: new (...args: any[]) => (string | false | HTMLElement) & {};
    } | {
        type: () => string | false | HTMLElement;
    } | {
        type: ((new (...args: any[]) => (string | false | HTMLElement) & {}) | (() => string | false | HTMLElement))[];
    }, "default"> & {
        default: "body";
    }, "default"> & {
        default: "body";
    };
    readonly autoUpdateOnClosed: BooleanConstructor;
    readonly gpuAcceleration: BooleanConstructor;
    readonly destoryedOnClosed: BooleanConstructor;
    readonly referenceProps: vue_demi.PropType<Record<string, any>>;
    readonly popupProps: vue_demi.PropType<Record<string, any>>;
    readonly popupWrapper: vue_demi.PropType<(popup: vue_demi.VNode<vue_demi.RendererNode, vue_demi.RendererElement, {
        [key: string]: any;
    }> | null) => vue_demi.VNode<vue_demi.RendererNode, vue_demi.RendererElement, {
        [key: string]: any;
    }>>;
    readonly floatingWrapper: vue_demi.PropType<(popup: vue_demi.VNode<vue_demi.RendererNode, vue_demi.RendererElement, {
        [key: string]: any;
    }> | null) => vue_demi.VNode<vue_demi.RendererNode, vue_demi.RendererElement, {
        [key: string]: any;
    }>>;
    readonly zIndex: NumberConstructor;
    readonly title: vue_demi.PropType<string | (() => vue_demi.VNode<vue_demi.RendererNode, vue_demi.RendererElement, {
        [key: string]: any;
    }>)>;
    readonly defaultOpen: BooleanConstructor;
    readonly interactions: Omit<{
        type: new (...args: any[]) => Interaction[];
    } | {
        type: () => Interaction[];
    } | {
        type: ((new (...args: any[]) => Interaction[]) | (() => Interaction[]))[];
    }, "default"> & {
        default: () => string[];
    };
    readonly clickDelay: vue_demi.PropType<number>;
    readonly hoverDelay: vue_demi.PropType<number>;
    readonly focusDelay: vue_demi.PropType<number>;
    readonly theme: Omit<{
        type: new (...args: any[]) => ("dark" | "light") & {};
    } | {
        type: () => "dark" | "light";
    } | {
        type: ((new (...args: any[]) => ("dark" | "light") & {}) | (() => "dark" | "light"))[];
    }, "default"> & {
        default: "line";
    };
    readonly size: Omit<{
        type: new (...args: any[]) => ("small" | "meduim") & {};
    } | {
        type: () => "small" | "meduim";
    } | {
        type: ((new (...args: any[]) => ("small" | "meduim") & {}) | (() => "small" | "meduim"))[];
    }, "default"> & {
        default: "meduim";
    };
    readonly transitionProps: Omit<{
        type: new (...args: any[]) => (string | Record<string, any>) & {};
    } | {
        type: () => string | Record<string, any>;
    } | {
        type: ((new (...args: any[]) => (string | Record<string, any>) & {}) | (() => string | Record<string, any>))[];
    }, "default"> & {
        default: "visoning-popover";
    };
    readonly showArrow: Omit<{
        type: BooleanConstructor;
    }, "default"> & {
        default: true;
    };
    readonly arrowProps: vue_demi.PropType<Record<string, any>>;
    readonly popoverProps: vue_demi.PropType<Record<string, any>>;
    readonly contentProps: vue_demi.PropType<Record<string, any>>;
    readonly popoverWrapper: vue_demi.PropType<(popup: vue_demi.VNode<vue_demi.RendererNode, vue_demi.RendererElement, {
        [key: string]: any;
    }> | null) => vue_demi.VNode<vue_demi.RendererNode, vue_demi.RendererElement, {
        [key: string]: any;
    }>>;
}, {
    readonly textAlign: "start";
    readonly open: undefined;
    readonly interactions: () => string[];
    readonly keepOpenWhenPopupHover: true;
    readonly closeWhenClickOutside: true;
    readonly theme: "line";
    readonly size: "meduim";
    readonly transitionProps: "visoning-popover";
    readonly showArrow: true;
    readonly appendTo: "body";
    readonly shift: true;
    readonly placement: "bottom";
    readonly strategy: "absolute";
    readonly autoUpdate: true;
}>, () => vue_demi.VNode<vue_demi.RendererNode, vue_demi.RendererElement, {
    [key: string]: any;
}>, unknown, {}, {}, vue_demi.ComponentOptionsMixin, vue_demi.ComponentOptionsMixin, {}, string, vue_demi.VNodeProps & vue_demi.AllowedComponentProps & vue_demi.ComponentCustomProps, Readonly<vue_demi.ExtractPropTypes<_visoning_vue_utility.WithDefaultProps<{
    readonly content: vue_demi.PropType<string | (() => vue_demi.VNode<vue_demi.RendererNode, vue_demi.RendererElement, {
        [key: string]: any;
    }>)>;
    readonly textAlign: vue_demi.PropType<"right" | "left" | "start" | "end" | "center" | "justify" | "match-parent">;
    readonly tooltipProps: vue_demi.PropType<Record<string, any>>;
    readonly tooltipWrapper: vue_demi.PropType<(popup: vue_demi.VNode<vue_demi.RendererNode, vue_demi.RendererElement, {
        [key: string]: any;
    }> | null) => vue_demi.VNode<vue_demi.RendererNode, vue_demi.RendererElement, {
        [key: string]: any;
    }>>;
    readonly onFloatingDataUpdate: vue_demi.PropType<(data: {
        x: number | null;
        y: number | null;
        strategy: _floating_ui_core.Strategy;
        placement: _floating_ui_core.Placement;
        middlewareData: {
            [x: string]: any;
            arrow?: {
                x?: number | undefined;
                y?: number | undefined;
                centerOffset: number;
            } | undefined;
            autoPlacement?: {
                index?: number | undefined;
                overflows: {
                    placement: _floating_ui_core.Placement;
                    overflows: number[];
                }[];
            } | undefined;
            flip?: {
                index?: number | undefined;
                overflows: {
                    placement: _floating_ui_core.Placement;
                    overflows: number[];
                }[];
            } | undefined;
            hide?: {
                referenceHidden?: boolean | undefined;
                escaped?: boolean | undefined;
                referenceHiddenOffsets?: {
                    top: number;
                    right: number;
                    bottom: number;
                    left: number;
                } | undefined;
                escapedOffsets?: {
                    top: number;
                    right: number;
                    bottom: number;
                    left: number;
                } | undefined;
            } | undefined;
            offset?: {
                x: number;
                y: number;
            } | undefined;
            shift?: {
                x: number;
                y: number;
            } | undefined;
        };
    }) => void>;
    readonly 'onUpdate:open': vue_demi.PropType<(open: boolean, info: InteractionInfo) => void>;
    readonly onOpen: vue_demi.PropType<(info: InteractionInfo) => void>;
    readonly onClose: vue_demi.PropType<(info: InteractionInfo) => void>;
    readonly open: Omit<{
        type: BooleanConstructor;
    }, "default"> & {
        default: undefined;
    };
    readonly delay: vue_demi.PropType<number>;
    readonly shift: Omit<Omit<{
        type: new (...args: any[]) => (boolean | _floating_ui_core.ShiftOptions) & {};
    } | {
        type: () => boolean | _floating_ui_core.ShiftOptions;
    } | {
        type: ((new (...args: any[]) => (boolean | _floating_ui_core.ShiftOptions) & {}) | (() => boolean | _floating_ui_core.ShiftOptions))[];
    }, "default"> & {
        default: true;
    }, "default"> & {
        default: true;
    };
    readonly disabled: BooleanConstructor;
    readonly closeWhenClickOutside: Omit<{
        type: BooleanConstructor;
    }, "default"> & {
        default: true;
    };
    readonly floating: {
        type: vue_demi.PropType<HTMLElement | null>;
    };
    readonly reference: {
        type: vue_demi.PropType<ReferenceType | null>;
    };
    readonly keepOpenWhenPopupHover: Omit<{
        type: BooleanConstructor;
    }, "default"> & {
        default: true;
    };
    readonly placement: Omit<Omit<Omit<{
        type: new (...args: any[]) => _floating_ui_core.Placement & {};
    } | {
        type: () => _floating_ui_core.Placement;
    } | {
        type: ((new (...args: any[]) => _floating_ui_core.Placement & {}) | (() => _floating_ui_core.Placement))[];
    }, "default"> & {
        default: "bottom";
    }, "default"> & {
        default: "bottom";
    }, "default"> & {
        default: "bottom";
    };
    readonly strategy: Omit<Omit<Omit<{
        type: new (...args: any[]) => _floating_ui_core.Strategy & {};
    } | {
        type: () => _floating_ui_core.Strategy;
    } | {
        type: ((new (...args: any[]) => _floating_ui_core.Strategy & {}) | (() => _floating_ui_core.Strategy))[];
    }, "default"> & {
        default: "absolute";
    }, "default"> & {
        default: "absolute";
    }, "default"> & {
        default: "absolute";
    };
    readonly middleware: vue_demi.PropType<_floating_ui_core.Middleware[]>;
    readonly arrow: vue_demi.PropType<CreateArrow>;
    readonly autoPlacement: vue_demi.PropType<boolean | _floating_ui_core.AutoPlacementOptions>;
    readonly flip: vue_demi.PropType<boolean | _floating_ui_core.FlipOptions>;
    readonly offset: vue_demi.PropType<_floating_ui_core.OffsetOptions>;
    readonly autoUpdate: Omit<Omit<Omit<{
        type: new (...args: any[]) => (boolean | UseAutoUpdateOptions) & {};
    } | {
        type: () => boolean | UseAutoUpdateOptions;
    } | {
        type: ((new (...args: any[]) => (boolean | UseAutoUpdateOptions) & {}) | (() => boolean | UseAutoUpdateOptions))[];
    }, "default"> & {
        default: true;
    }, "default"> & {
        default: true;
    }, "default"> & {
        default: true;
    };
    readonly virtualElement: vue_demi.PropType<_floating_ui_dom.VirtualElement>;
    readonly appendTo: Omit<Omit<{
        type: new (...args: any[]) => (string | false | HTMLElement) & {};
    } | {
        type: () => string | false | HTMLElement;
    } | {
        type: ((new (...args: any[]) => (string | false | HTMLElement) & {}) | (() => string | false | HTMLElement))[];
    }, "default"> & {
        default: "body";
    }, "default"> & {
        default: "body";
    };
    readonly autoUpdateOnClosed: BooleanConstructor;
    readonly gpuAcceleration: BooleanConstructor;
    readonly destoryedOnClosed: BooleanConstructor;
    readonly referenceProps: vue_demi.PropType<Record<string, any>>;
    readonly popupProps: vue_demi.PropType<Record<string, any>>;
    readonly popupWrapper: vue_demi.PropType<(popup: vue_demi.VNode<vue_demi.RendererNode, vue_demi.RendererElement, {
        [key: string]: any;
    }> | null) => vue_demi.VNode<vue_demi.RendererNode, vue_demi.RendererElement, {
        [key: string]: any;
    }>>;
    readonly floatingWrapper: vue_demi.PropType<(popup: vue_demi.VNode<vue_demi.RendererNode, vue_demi.RendererElement, {
        [key: string]: any;
    }> | null) => vue_demi.VNode<vue_demi.RendererNode, vue_demi.RendererElement, {
        [key: string]: any;
    }>>;
    readonly zIndex: NumberConstructor;
    readonly title: vue_demi.PropType<string | (() => vue_demi.VNode<vue_demi.RendererNode, vue_demi.RendererElement, {
        [key: string]: any;
    }>)>;
    readonly defaultOpen: BooleanConstructor;
    readonly interactions: Omit<{
        type: new (...args: any[]) => Interaction[];
    } | {
        type: () => Interaction[];
    } | {
        type: ((new (...args: any[]) => Interaction[]) | (() => Interaction[]))[];
    }, "default"> & {
        default: () => string[];
    };
    readonly clickDelay: vue_demi.PropType<number>;
    readonly hoverDelay: vue_demi.PropType<number>;
    readonly focusDelay: vue_demi.PropType<number>;
    readonly theme: Omit<{
        type: new (...args: any[]) => ("dark" | "light") & {};
    } | {
        type: () => "dark" | "light";
    } | {
        type: ((new (...args: any[]) => ("dark" | "light") & {}) | (() => "dark" | "light"))[];
    }, "default"> & {
        default: "line";
    };
    readonly size: Omit<{
        type: new (...args: any[]) => ("small" | "meduim") & {};
    } | {
        type: () => "small" | "meduim";
    } | {
        type: ((new (...args: any[]) => ("small" | "meduim") & {}) | (() => "small" | "meduim"))[];
    }, "default"> & {
        default: "meduim";
    };
    readonly transitionProps: Omit<{
        type: new (...args: any[]) => (string | Record<string, any>) & {};
    } | {
        type: () => string | Record<string, any>;
    } | {
        type: ((new (...args: any[]) => (string | Record<string, any>) & {}) | (() => string | Record<string, any>))[];
    }, "default"> & {
        default: "visoning-popover";
    };
    readonly showArrow: Omit<{
        type: BooleanConstructor;
    }, "default"> & {
        default: true;
    };
    readonly arrowProps: vue_demi.PropType<Record<string, any>>;
    readonly popoverProps: vue_demi.PropType<Record<string, any>>;
    readonly contentProps: vue_demi.PropType<Record<string, any>>;
    readonly popoverWrapper: vue_demi.PropType<(popup: vue_demi.VNode<vue_demi.RendererNode, vue_demi.RendererElement, {
        [key: string]: any;
    }> | null) => vue_demi.VNode<vue_demi.RendererNode, vue_demi.RendererElement, {
        [key: string]: any;
    }>>;
}, {
    readonly textAlign: "start";
    readonly open: undefined;
    readonly interactions: () => string[];
    readonly keepOpenWhenPopupHover: true;
    readonly closeWhenClickOutside: true;
    readonly theme: "line";
    readonly size: "meduim";
    readonly transitionProps: "visoning-popover";
    readonly showArrow: true;
    readonly appendTo: "body";
    readonly shift: true;
    readonly placement: "bottom";
    readonly strategy: "absolute";
    readonly autoUpdate: true;
}>>>, {
    readonly open: boolean;
    readonly shift: boolean | _floating_ui_core.ShiftOptions;
    readonly disabled: boolean;
    readonly closeWhenClickOutside: boolean;
    readonly keepOpenWhenPopupHover: boolean;
    readonly placement: _floating_ui_core.Placement;
    readonly strategy: _floating_ui_core.Strategy;
    readonly autoUpdate: boolean | UseAutoUpdateOptions;
    readonly appendTo: string | false | HTMLElement;
    readonly autoUpdateOnClosed: boolean;
    readonly gpuAcceleration: boolean;
    readonly destoryedOnClosed: boolean;
    readonly defaultOpen: boolean;
    readonly interactions: Interaction[];
    readonly theme: "dark" | "light";
    readonly size: "small" | "meduim";
    readonly transitionProps: string | Record<string, any>;
    readonly showArrow: boolean;
    readonly textAlign: "right" | "left" | "start" | "end" | "center" | "justify" | "match-parent";
}>;

interface TooltipExposed extends PopoverExposed {
}
declare type TooltipArrowSlotProps = PopoverArrowSlotProps;
declare const TooltipPropsType: {
    /**
     * support: string | VNode | slot
     */
    readonly content: PropType<string | (() => VNode)>;
    /**
     * align tooltip content. enum of CSS text-align.
     * @default 'start'
     */
    readonly textAlign: PropType<"right" | "left" | "start" | "end" | "center" | "justify" | "match-parent">;
    /**
     * HTML attributes of node.
     */
    readonly tooltipProps: PropType<Record<string, any>>;
    /**
     * Custom tooltip node wrapper.
     */
    readonly tooltipWrapper: PropType<(popup: VNode<vue_demi.RendererNode, vue_demi.RendererElement, {
        [key: string]: any;
    }> | null) => VNode<vue_demi.RendererNode, vue_demi.RendererElement, {
        [key: string]: any;
    }>>;
    readonly onFloatingDataUpdate: PropType<(data: {
        x: number | null;
        y: number | null;
        strategy: _floating_ui_core.Strategy;
        placement: _floating_ui_core.Placement;
        middlewareData: {
            [x: string]: any;
            arrow?: {
                x?: number | undefined;
                y?: number | undefined;
                centerOffset: number;
            } | undefined;
            autoPlacement?: {
                index?: number | undefined;
                overflows: {
                    placement: _floating_ui_core.Placement;
                    overflows: number[];
                }[];
            } | undefined;
            flip?: {
                index?: number | undefined;
                overflows: {
                    placement: _floating_ui_core.Placement;
                    overflows: number[];
                }[];
            } | undefined;
            hide?: {
                referenceHidden?: boolean | undefined;
                escaped?: boolean | undefined;
                referenceHiddenOffsets?: {
                    top: number;
                    right: number;
                    bottom: number;
                    left: number;
                } | undefined;
                escapedOffsets?: {
                    top: number;
                    right: number;
                    bottom: number;
                    left: number;
                } | undefined;
            } | undefined;
            offset?: {
                x: number;
                y: number;
            } | undefined;
            shift?: {
                x: number;
                y: number;
            } | undefined;
        };
    }) => void>;
    readonly 'onUpdate:open': PropType<(open: boolean, info: InteractionInfo) => void>;
    readonly onOpen: PropType<(info: InteractionInfo) => void>;
    readonly onClose: PropType<(info: InteractionInfo) => void>;
    readonly open: Omit<{
        type: BooleanConstructor;
    }, "default"> & {
        default: undefined;
    };
    readonly delay: PropType<number>;
    readonly shift: Omit<Omit<{
        type: new (...args: any[]) => (boolean | _floating_ui_core.ShiftOptions) & {};
    } | {
        type: () => boolean | _floating_ui_core.ShiftOptions;
    } | {
        type: ((new (...args: any[]) => (boolean | _floating_ui_core.ShiftOptions) & {}) | (() => boolean | _floating_ui_core.ShiftOptions))[];
    }, "default"> & {
        default: true;
    }, "default"> & {
        default: true;
    };
    readonly disabled: BooleanConstructor;
    readonly closeWhenClickOutside: Omit<{
        type: BooleanConstructor;
    }, "default"> & {
        default: true;
    };
    readonly floating: {
        type: PropType<HTMLElement | null>;
    };
    readonly reference: {
        type: PropType<ReferenceType | null>;
    };
    readonly keepOpenWhenPopupHover: Omit<{
        type: BooleanConstructor;
    }, "default"> & {
        default: true;
    };
    readonly placement: Omit<Omit<Omit<{
        type: new (...args: any[]) => _floating_ui_core.Placement & {};
    } | {
        type: () => _floating_ui_core.Placement;
    } | {
        type: ((new (...args: any[]) => _floating_ui_core.Placement & {}) | (() => _floating_ui_core.Placement))[];
    }, "default"> & {
        default: "bottom";
    }, "default"> & {
        default: "bottom";
    }, "default"> & {
        default: "bottom";
    };
    readonly strategy: Omit<Omit<Omit<{
        type: new (...args: any[]) => _floating_ui_core.Strategy & {};
    } | {
        type: () => _floating_ui_core.Strategy;
    } | {
        type: ((new (...args: any[]) => _floating_ui_core.Strategy & {}) | (() => _floating_ui_core.Strategy))[];
    }, "default"> & {
        default: "absolute";
    }, "default"> & {
        default: "absolute";
    }, "default"> & {
        default: "absolute";
    };
    readonly middleware: PropType<_floating_ui_core.Middleware[]>;
    readonly arrow: PropType<CreateArrow>;
    readonly autoPlacement: PropType<boolean | _floating_ui_core.AutoPlacementOptions>;
    readonly flip: PropType<boolean | _floating_ui_core.FlipOptions>;
    readonly offset: PropType<_floating_ui_core.OffsetOptions>;
    readonly autoUpdate: Omit<Omit<Omit<{
        type: new (...args: any[]) => (boolean | UseAutoUpdateOptions) & {};
    } | {
        type: () => boolean | UseAutoUpdateOptions;
    } | {
        type: ((new (...args: any[]) => (boolean | UseAutoUpdateOptions) & {}) | (() => boolean | UseAutoUpdateOptions))[];
    }, "default"> & {
        default: true;
    }, "default"> & {
        default: true;
    }, "default"> & {
        default: true;
    };
    readonly virtualElement: PropType<_floating_ui_dom.VirtualElement>;
    readonly appendTo: Omit<Omit<{
        type: new (...args: any[]) => (string | false | HTMLElement) & {};
    } | {
        type: () => string | false | HTMLElement;
    } | {
        type: ((new (...args: any[]) => (string | false | HTMLElement) & {}) | (() => string | false | HTMLElement))[];
    }, "default"> & {
        default: "body";
    }, "default"> & {
        default: "body";
    };
    readonly autoUpdateOnClosed: BooleanConstructor;
    readonly gpuAcceleration: BooleanConstructor;
    readonly destoryedOnClosed: BooleanConstructor;
    readonly referenceProps: PropType<Record<string, any>>;
    readonly popupProps: PropType<Record<string, any>>;
    readonly popupWrapper: PropType<(popup: VNode<vue_demi.RendererNode, vue_demi.RendererElement, {
        [key: string]: any;
    }> | null) => VNode<vue_demi.RendererNode, vue_demi.RendererElement, {
        [key: string]: any;
    }>>;
    readonly floatingWrapper: PropType<(popup: VNode<vue_demi.RendererNode, vue_demi.RendererElement, {
        [key: string]: any;
    }> | null) => VNode<vue_demi.RendererNode, vue_demi.RendererElement, {
        [key: string]: any;
    }>>;
    readonly zIndex: NumberConstructor;
    readonly title: PropType<string | (() => VNode<vue_demi.RendererNode, vue_demi.RendererElement, {
        [key: string]: any;
    }>)>;
    readonly defaultOpen: BooleanConstructor;
    readonly interactions: Omit<{
        type: new (...args: any[]) => Interaction[];
    } | {
        type: () => Interaction[];
    } | {
        type: ((new (...args: any[]) => Interaction[]) | (() => Interaction[]))[];
    }, "default"> & {
        default: () => string[];
    };
    readonly clickDelay: PropType<number>;
    readonly hoverDelay: PropType<number>;
    readonly focusDelay: PropType<number>;
    readonly theme: Omit<{
        type: new (...args: any[]) => ("dark" | "light") & {};
    } | {
        type: () => "dark" | "light";
    } | {
        type: ((new (...args: any[]) => ("dark" | "light") & {}) | (() => "dark" | "light"))[];
    }, "default"> & {
        default: "line";
    };
    readonly size: Omit<{
        type: new (...args: any[]) => ("small" | "meduim") & {};
    } | {
        type: () => "small" | "meduim";
    } | {
        type: ((new (...args: any[]) => ("small" | "meduim") & {}) | (() => "small" | "meduim"))[];
    }, "default"> & {
        default: "meduim";
    };
    readonly transitionProps: Omit<{
        type: new (...args: any[]) => (string | Record<string, any>) & {};
    } | {
        type: () => string | Record<string, any>;
    } | {
        type: ((new (...args: any[]) => (string | Record<string, any>) & {}) | (() => string | Record<string, any>))[];
    }, "default"> & {
        default: "visoning-popover";
    };
    readonly showArrow: Omit<{
        type: BooleanConstructor;
    }, "default"> & {
        default: true;
    };
    readonly arrowProps: PropType<Record<string, any>>;
    readonly popoverProps: PropType<Record<string, any>>;
    readonly contentProps: PropType<Record<string, any>>;
    readonly popoverWrapper: PropType<(popup: VNode<vue_demi.RendererNode, vue_demi.RendererElement, {
        [key: string]: any;
    }> | null) => VNode<vue_demi.RendererNode, vue_demi.RendererElement, {
        [key: string]: any;
    }>>;
};
declare const TooltipDefaultProps: {
    readonly textAlign: "start";
    readonly open: undefined;
    readonly interactions: () => string[];
    readonly keepOpenWhenPopupHover: true;
    readonly closeWhenClickOutside: true;
    readonly theme: "line";
    readonly size: "meduim";
    readonly transitionProps: "visoning-popover";
    readonly showArrow: true;
    readonly appendTo: "body";
    readonly shift: true;
    readonly placement: "bottom";
    readonly strategy: "absolute";
    readonly autoUpdate: true;
};
declare const TooltipProps: _visoning_vue_utility.WithDefaultProps<{
    /**
     * support: string | VNode | slot
     */
    readonly content: PropType<string | (() => VNode)>;
    /**
     * align tooltip content. enum of CSS text-align.
     * @default 'start'
     */
    readonly textAlign: PropType<"right" | "left" | "start" | "end" | "center" | "justify" | "match-parent">;
    /**
     * HTML attributes of node.
     */
    readonly tooltipProps: PropType<Record<string, any>>;
    /**
     * Custom tooltip node wrapper.
     */
    readonly tooltipWrapper: PropType<(popup: VNode<vue_demi.RendererNode, vue_demi.RendererElement, {
        [key: string]: any;
    }> | null) => VNode<vue_demi.RendererNode, vue_demi.RendererElement, {
        [key: string]: any;
    }>>;
    readonly onFloatingDataUpdate: PropType<(data: {
        x: number | null;
        y: number | null;
        strategy: _floating_ui_core.Strategy;
        placement: _floating_ui_core.Placement;
        middlewareData: {
            [x: string]: any;
            arrow?: {
                x?: number | undefined;
                y?: number | undefined;
                centerOffset: number;
            } | undefined;
            autoPlacement?: {
                index?: number | undefined;
                overflows: {
                    placement: _floating_ui_core.Placement;
                    overflows: number[];
                }[];
            } | undefined;
            flip?: {
                index?: number | undefined;
                overflows: {
                    placement: _floating_ui_core.Placement;
                    overflows: number[];
                }[];
            } | undefined;
            hide?: {
                referenceHidden?: boolean | undefined;
                escaped?: boolean | undefined;
                referenceHiddenOffsets?: {
                    top: number;
                    right: number;
                    bottom: number;
                    left: number;
                } | undefined;
                escapedOffsets?: {
                    top: number;
                    right: number;
                    bottom: number;
                    left: number;
                } | undefined;
            } | undefined;
            offset?: {
                x: number;
                y: number;
            } | undefined;
            shift?: {
                x: number;
                y: number;
            } | undefined;
        };
    }) => void>;
    readonly 'onUpdate:open': PropType<(open: boolean, info: InteractionInfo) => void>;
    readonly onOpen: PropType<(info: InteractionInfo) => void>;
    readonly onClose: PropType<(info: InteractionInfo) => void>;
    readonly open: Omit<{
        type: BooleanConstructor;
    }, "default"> & {
        default: undefined;
    };
    readonly delay: PropType<number>;
    readonly shift: Omit<Omit<{
        type: new (...args: any[]) => (boolean | _floating_ui_core.ShiftOptions) & {};
    } | {
        type: () => boolean | _floating_ui_core.ShiftOptions;
    } | {
        type: ((new (...args: any[]) => (boolean | _floating_ui_core.ShiftOptions) & {}) | (() => boolean | _floating_ui_core.ShiftOptions))[];
    }, "default"> & {
        default: true;
    }, "default"> & {
        default: true;
    };
    readonly disabled: BooleanConstructor;
    readonly closeWhenClickOutside: Omit<{
        type: BooleanConstructor;
    }, "default"> & {
        default: true;
    };
    readonly floating: {
        type: PropType<HTMLElement | null>;
    };
    readonly reference: {
        type: PropType<ReferenceType | null>;
    };
    readonly keepOpenWhenPopupHover: Omit<{
        type: BooleanConstructor;
    }, "default"> & {
        default: true;
    };
    readonly placement: Omit<Omit<Omit<{
        type: new (...args: any[]) => _floating_ui_core.Placement & {};
    } | {
        type: () => _floating_ui_core.Placement;
    } | {
        type: ((new (...args: any[]) => _floating_ui_core.Placement & {}) | (() => _floating_ui_core.Placement))[];
    }, "default"> & {
        default: "bottom";
    }, "default"> & {
        default: "bottom";
    }, "default"> & {
        default: "bottom";
    };
    readonly strategy: Omit<Omit<Omit<{
        type: new (...args: any[]) => _floating_ui_core.Strategy & {};
    } | {
        type: () => _floating_ui_core.Strategy;
    } | {
        type: ((new (...args: any[]) => _floating_ui_core.Strategy & {}) | (() => _floating_ui_core.Strategy))[];
    }, "default"> & {
        default: "absolute";
    }, "default"> & {
        default: "absolute";
    }, "default"> & {
        default: "absolute";
    };
    readonly middleware: PropType<_floating_ui_core.Middleware[]>;
    readonly arrow: PropType<CreateArrow>;
    readonly autoPlacement: PropType<boolean | _floating_ui_core.AutoPlacementOptions>;
    readonly flip: PropType<boolean | _floating_ui_core.FlipOptions>;
    readonly offset: PropType<_floating_ui_core.OffsetOptions>;
    readonly autoUpdate: Omit<Omit<Omit<{
        type: new (...args: any[]) => (boolean | UseAutoUpdateOptions) & {};
    } | {
        type: () => boolean | UseAutoUpdateOptions;
    } | {
        type: ((new (...args: any[]) => (boolean | UseAutoUpdateOptions) & {}) | (() => boolean | UseAutoUpdateOptions))[];
    }, "default"> & {
        default: true;
    }, "default"> & {
        default: true;
    }, "default"> & {
        default: true;
    };
    readonly virtualElement: PropType<_floating_ui_dom.VirtualElement>;
    readonly appendTo: Omit<Omit<{
        type: new (...args: any[]) => (string | false | HTMLElement) & {};
    } | {
        type: () => string | false | HTMLElement;
    } | {
        type: ((new (...args: any[]) => (string | false | HTMLElement) & {}) | (() => string | false | HTMLElement))[];
    }, "default"> & {
        default: "body";
    }, "default"> & {
        default: "body";
    };
    readonly autoUpdateOnClosed: BooleanConstructor;
    readonly gpuAcceleration: BooleanConstructor;
    readonly destoryedOnClosed: BooleanConstructor;
    readonly referenceProps: PropType<Record<string, any>>;
    readonly popupProps: PropType<Record<string, any>>;
    readonly popupWrapper: PropType<(popup: VNode<vue_demi.RendererNode, vue_demi.RendererElement, {
        [key: string]: any;
    }> | null) => VNode<vue_demi.RendererNode, vue_demi.RendererElement, {
        [key: string]: any;
    }>>;
    readonly floatingWrapper: PropType<(popup: VNode<vue_demi.RendererNode, vue_demi.RendererElement, {
        [key: string]: any;
    }> | null) => VNode<vue_demi.RendererNode, vue_demi.RendererElement, {
        [key: string]: any;
    }>>;
    readonly zIndex: NumberConstructor;
    readonly title: PropType<string | (() => VNode<vue_demi.RendererNode, vue_demi.RendererElement, {
        [key: string]: any;
    }>)>;
    readonly defaultOpen: BooleanConstructor;
    readonly interactions: Omit<{
        type: new (...args: any[]) => Interaction[];
    } | {
        type: () => Interaction[];
    } | {
        type: ((new (...args: any[]) => Interaction[]) | (() => Interaction[]))[];
    }, "default"> & {
        default: () => string[];
    };
    readonly clickDelay: PropType<number>;
    readonly hoverDelay: PropType<number>;
    readonly focusDelay: PropType<number>;
    readonly theme: Omit<{
        type: new (...args: any[]) => ("dark" | "light") & {};
    } | {
        type: () => "dark" | "light";
    } | {
        type: ((new (...args: any[]) => ("dark" | "light") & {}) | (() => "dark" | "light"))[];
    }, "default"> & {
        default: "line";
    };
    readonly size: Omit<{
        type: new (...args: any[]) => ("small" | "meduim") & {};
    } | {
        type: () => "small" | "meduim";
    } | {
        type: ((new (...args: any[]) => ("small" | "meduim") & {}) | (() => "small" | "meduim"))[];
    }, "default"> & {
        default: "meduim";
    };
    readonly transitionProps: Omit<{
        type: new (...args: any[]) => (string | Record<string, any>) & {};
    } | {
        type: () => string | Record<string, any>;
    } | {
        type: ((new (...args: any[]) => (string | Record<string, any>) & {}) | (() => string | Record<string, any>))[];
    }, "default"> & {
        default: "visoning-popover";
    };
    readonly showArrow: Omit<{
        type: BooleanConstructor;
    }, "default"> & {
        default: true;
    };
    readonly arrowProps: PropType<Record<string, any>>;
    readonly popoverProps: PropType<Record<string, any>>;
    readonly contentProps: PropType<Record<string, any>>;
    readonly popoverWrapper: PropType<(popup: VNode<vue_demi.RendererNode, vue_demi.RendererElement, {
        [key: string]: any;
    }> | null) => VNode<vue_demi.RendererNode, vue_demi.RendererElement, {
        [key: string]: any;
    }>>;
}, {
    readonly textAlign: "start";
    readonly open: undefined;
    readonly interactions: () => string[];
    readonly keepOpenWhenPopupHover: true;
    readonly closeWhenClickOutside: true;
    readonly theme: "line";
    readonly size: "meduim";
    readonly transitionProps: "visoning-popover";
    readonly showArrow: true;
    readonly appendTo: "body";
    readonly shift: true;
    readonly placement: "bottom";
    readonly strategy: "absolute";
    readonly autoUpdate: true;
}>;
declare type TooltipProps = ExtractPropTypes<typeof TooltipProps>;

export { AutoUpdateOptions, CreateArrow, FloatingData, ForwardReferenceContextValue, ForwardReferenceType, Interaction, Popover, PopoverArrowSlotProps, PopoverDefaultProps, PopoverExposed, PopoverProps, PopoverPropsType, PopoverTransitionName, Popup, PopupDefaultProps, PopupExposed, PopupProps, PopupPropsType, PopupSlotProps, Tooltip, TooltipArrowSlotProps, TooltipDefaultProps, TooltipExposed, TooltipProps, TooltipPropsType, createReferenceForwardContext, providePopupContextValue, useReferenceForwardContext, useSafeReferenceForwardContent };
